Package org.opensaml.saml.metadata.resolver.index

# Interface MetadataIndex

All Known Implementing Classes:
  `EndpointMetadataIndex`, `FunctionDrivenMetadataIndex`, `RoleMetadataIndex`, `SAMLArtifactMetadataIndex`

public interface MetadataIndex
A component which defines and supports indexing an `EntityDescriptor`, and corresponding lookup via a `CriteriaSet`, using one or more (possibly implementation-specific) instances of `MetadataIndexKey`.

## Method Summary

Modifier and Type
Method
Description
`Set<MetadataIndexKey>`
`generateKeys(CriteriaSet criteriaSet)`
Generate a set of one or more `MetadataIndexKey` instances based on the input `CriteriaSet`.
`Set<MetadataIndexKey>`
`generateKeys(EntityDescriptor descriptor)`
Generate a set of one or more `MetadataIndexKey` instances based on the input `EntityDescriptor`.

## Method Details

### generateKeys

@Nullable @Unmodifiable @NotLive Set<MetadataIndexKey> generateKeys(@Nonnull EntityDescriptor descriptor)
Generate a set of one or more `MetadataIndexKey` instances based on the input `EntityDescriptor`.

These index key instances reflect the type of indexing performed and "understood" by the implementation, and as such should complement the `MetadataIndexKey` types generated for descriptor lookup via `generateKeys(CriteriaSet)`.

Parameters:
  `descriptor` - the entity descriptor set to process
Returns:
  the set of index keys generated from the criteria. May be null or empty, but will not contain null elements.

### generateKeys

@Nullable @Unmodifiable @NotLive Set<MetadataIndexKey> generateKeys(@Nullable CriteriaSet criteriaSet)
Generate a set of one or more `MetadataIndexKey` instances based on the input `CriteriaSet`.

These index key instances reflect the type of indexing performed and "understood" by the implementation, and as such should complement the `MetadataIndexKey` types generated for descriptor indexing via `generateKeys(EntityDescriptor)`.

Parameters:
  `criteriaSet` - the criteria set to process
Returns:
  the set of index keys generated from the criteria. May be null or empty, but will not contain null elements.